** This file is part of aITALC
** Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
**-----------------------------------------------------------------------
** This subprogram exports the global variables "memomenta{1,2,...}" with
** the symbolic value of the momentum of another onshell particle.
** Suitable for pick up a proper set of momenta in fermion chains

** It requires to import "maxexternalfermionindex".
** Should be included on \section(regular) part of the create file in Diana

** Created 07/10/03
*********************************************************************************


** We let diana to choose them for us automatically, depending on the
** topology and channel...
\-

\if "\import(maxexternalfermionindex)" eq "0" then
** Do nothing
\else

  \if "\import(memomenta\import(fermionchannel)1)" ne "\(CREATED)" then
** Do nothing, already computed once with value!
  \else
** Go for the definition and compute it!


    \let(_iline,0)
* The increment of 1 unity is done better by \inc command in comparison
*    \let(_iline,\sum(\get(_iline),1))
    \while "\numcmp(\inc(_iline,1),\import(maxexternalfermionindex))" ne ">" do
      \export(memomentumaway,EMPTY)
      \Begin(foreach,e,1,\numberofexternallines())
        \let(_lc,\linefcount(-\e()))
        \let(_mo,\momentum(-\e(),))
        \let(_fo,\import(fflowout(\e())))
        \let(_ipart,\e())
        \if "\numcmp(\get(_lc),\get(_iline))" eq "=" then
** Set which is the particle index for the outgoing fermion flow
          \if "\get(_fo)" eq "YES" then
            \let(_rightaccompanier,\get(_ipart))
          \else
            \let(_leftaccompanier,\get(_ipart))
          \endif
        \else
** Set which is an appropriate momentum not belonging to the fermion line
          \if "\import(memomentumaway)" eq "EMPTY" then
             \export(memomentumaway,\get(_mo))
          \endif
          \let(_memomentum,\get(_mo))
        \endif
      \End(foreach)
      \export(memomenta\import(fermionchannel)\get(_iline),\replace(-,+,\get(_memomentum)))
      \export(memomentaaway\import(fermionchannel)\get(_iline),\replace(-,+,\import(memomentumaway)))
      \export(ifflowout\import(fermionchannel)\get(_iline),\get(_rightaccompanier))
      \export(ifflowin\import(fermionchannel)\get(_iline), \get(_leftaccompanier))
      \loop

    \killvar(_lc)
    \killvar(_mo)
    \killvar(_fo)
    \killvar(_ipart)
    \killvar(_memomentum)
    \killvar(_iline)

  \endif
\endif
\+
** $Id: memomentadefinition.prg,v 1.4 2004/10/20 14:11:29 alorca Exp $
