#-
* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
* Basic file to join together all the form factors and write fortran output

#define width "1"
#include `processname'.in #topologies0
#include `processname'.in #exts1
#include model.inc
#include Kit.inc
#define code "15"
#include legsindexdef.inc

CF ff;
.global
#$numberfunctions=0;
#do jtopo={`topologiesnames'}
 .sort
 S t`jtopo';
 G [t`jtopo'] = ff(t`jtopo');
 .sort
 #message [joinff: loading topology `jtopo']
 #message [joinff: we loop from j=`$first`jtopo'',`$last`jtopo'']

  #do j=`$first`jtopo'',`$last`jtopo''
   load FF`processname'/FF`code'D`j'.sav;
*   drop [Amplitude,`j'];
   id once ff(t`jtopo')= [Amplitude,`j'] + ff(t`jtopo');
   .sort
* Next 'if' rewrite the storage file after 10 loadings happened, so we can
* reload as many times as necessary (otherwise it crashes for more 
* than 6050 defined variables!)
   #if {`j'%20} == 0
    delete storage;
    .sort
   #endif
  #enddo

*Killing the dummy running form factors at the end
 id ff(?a)=0;
 .sort

 #if ((`LEGS' == 4) || (`LEGS' == 5))


*** Association crossing and direct symmetries in loop arguments!
  #call loopsymmetries()
  #call canceldens()
  #call nosymboliccouplings()
  .sort

*Possible reduccion
*  #call reductionDD02(1)
** Don't run simplifygrams more than once or you will see Grams
** in your numerator.
*  #call simplifygrams()
*  #call neglectmass(0)

*  b Pi,e,i_,Targ,den,T0,T1,T2,T3,T4,IGram,sw,cw,CKM,CKMD,transv,longit;
*Only to log file
*  print +s +f;

*  print +s;
  .sort

  #include aITALC.inc
*-------------------------------------------------------------------------------
** Collect the topologies into fortran files

  #call aitalcnotation(`width')
  #call identifyintegrals()
  b matrixe;
  print +s +f;
  .sort

  #do ch={`fermioncurrentsnames'}
   #do i1=1,`i1max'
    #do i2=1,`i2max'
     L [`ch',t`jtopo',`i1',`i2']=[t`jtopo'][matrixe(`ch',`i1',`i2')];
    #enddo
   #enddo
  #enddo
*  format doublefortran;
b Pi,e,im,den,cden,IGram3,IGram2,CKM,CKMD,cw;
*ab LI;
  format doublefortran;
*Half of the size than next
*  b e,Pi,im,LI;

  .sort
  #do ch={`fermioncurrentsnames'}

* And from now just the topological parts
#write <F_`jtopo'.F> "C This file <F_`jtopo'.F> is part of aITALC"
#write <F_`jtopo'.F> "C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>"
#write <F_`jtopo'.F> "C Generated automatically by FORM3: file \"joinff.frm\""
#write <F_`jtopo'.F> "C ----------------------------------------------------------------------"
#write <F_`jtopo'.F> "      SUBROUTINE F_`ch'_`jtopo'(FF_`ch'_`jtopo')"
#write <F_`jtopo'.F> ""
#write <F_`jtopo'.F> "      IMPLICIT NONE"
#write <F_`jtopo'.F> "      DOUBLE COMPLEX FF_`ch'_`jtopo'(`i1max',`i2max')"
  #if `LEVEL' == tree
  #elseif `LEVEL' == loop
#write <F_`jtopo'.F> "#include <looptools.h>"
#write <F_`jtopo'.F> "#include <loopfunctions.hf>"
#write <F_`jtopo'.F> "#include <lidefinitions.hf>"  
  #else
   #message [joinmm: Bad defined preprocessed variable "LEVEL"=`LEVEL']
   .end
  #endif
#write <F_`jtopo'.F> "#include <variablelist.hf>"
  #do i1=1,`i1max'
#write <F_`jtopo'.F> "C ----------------------------------------------------------------------"
   #do i2=1,`i2max'
#write <F_`jtopo'.F> "      FF_`ch'_`jtopo'(`i1',`i2') = %e",[`ch',t`jtopo',`i1',`i2'](FF_`ch'_`jtopo'(`i1',`i2'))
   #enddo
  #enddo
#write <F_`jtopo'.F> "C ----------------------------------------------------------------------"
#write <F_`jtopo'.F> "      RETURN"
#write <F_`jtopo'.F> "      END"
#write <F_`jtopo'.F> "C **********************************************************************"
 #enddo
#close <F_`jtopo'.F>

** For the self-energies, the following part of the file is useful.
 #elseif `LEGS' == 2

  Multiply +i_;
  .sort

  G [DSelf,t`jtopo'] = derivative*[t`jtopo'];
  .sort
  hide [t`jtopo'],[DSelf,t`jtopo'];
  .sort
  drop;
  unhide;
  #call derivateself()
** Making the conditions
  id sman=`em1'^2;
  al 1/sman=`em1'^(-2);
  id Targ(sman,?a)=Targ(`emm1',?a);

  #call aitalcnotation(1)

  b Pi,e,im,Targ,den,T0,DT0,T1,T2,T3,T4,IGram,sw,CKM,CKMD,cw,transv,longit;
  print +s;
  .sort
** Endif for the legs case
 #endif
.store
delete storage;
drop;
.sort
** For the topology case
#enddo

*-------------------------------------------------------------------------------
** With the first part we write the subroutines F{STU}{tree,loop}

#write <F_`LEVEL'.f> "C This file <F_`LEVEL'.f> is part of aITALC"
#write <F_`LEVEL'.f> "C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>"
#write <F_`LEVEL'.f> "C Generated automatically by FORM3: file \"joinff.frm\""
 #do ch={`fermioncurrentsnames'}
#write <F_`LEVEL'.f> "C **********************************************************************"
#write <F_`LEVEL'.f> "      subroutine F_`ch'_`LEVEL'(FF_`ch'_`LEVEL')"
#write <F_`LEVEL'.f> ""
#write <F_`LEVEL'.f> "      implicit none"
#write <F_`LEVEL'.f> "      integer i1,i2"
#write <F_`LEVEL'.f> "      double complex FF_`ch'_`LEVEL'(`i1max',`i2max')"
  #do jtopo={`topologiesnames'}
#write <F_`LEVEL'.f> "     &              ,FF_`ch'_`jtopo'(`i1max',`i2max')"
  #enddo
#write <F_`LEVEL'.f> "C ----------------------------------------------------------------------"
  #do jtopo={`topologiesnames'}
#write <F_`LEVEL'.f> "      CALL F_`ch'_`jtopo'(FF_`ch'_`jtopo')"
  #enddo
#write <F_`LEVEL'.f> "C ----------------------------------------------------------------------"
#write <F_`LEVEL'.f> "      do i2=1,`i2max'"
#write <F_`LEVEL'.f> "        do i1=1,`i1max'"
#write <F_`LEVEL'.f> "      FF_`ch'_`LEVEL'(i1,i2)= DCMPLX(0)"
  #do jtopo={`topologiesnames'}
#write <F_`LEVEL'.f> "     &             + FF_`ch'_`jtopo'(i1,i2)"
  #enddo
#write <F_`LEVEL'.f> "        enddo"
#write <F_`LEVEL'.f> "      enddo"
#write <F_`LEVEL'.f> "C ----------------------------------------------------------------------"
#write <F_`LEVEL'.f> "      return"
#write <F_`LEVEL'.f> "      end"
 #enddo
#close <F_`LEVEL'.f>

** And last but not least, the identification of loop integrals, to be defined
** on a separate file li.hf, only existing for loop level.

#write <li.F.1> "C This file <F_`LEVEL'.f> is part of aITALC"
#write <li.F.1> "C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>"
#write <li.F.1> "C Generated automatically by FORM3: file \"joinff.frm\""
#write <li.F.1> "C ----------------------------------------------------------------------"
#write <li.F.1> "      subroutine LoopIntegrals()"
#write <li.F.1> "C ----------------------------------------------------------------------"
#write <li.F.1> "      implicit none"
#write <li.F.1> "#include <variablelist.hf>"
#write <li.F.1> "#include <loopfunctions.hf>"
#write <li.F.1> "#include <lidefinitions.hf>"
#write <li.F.1> "#include <looptools.h>"
#write <li.F.1> "C ----------------------------------------------------------------------"
#write <li.F.1> "C Bad news, next is produced by make via grepping on joinff.1.log"
#write <li.F.1> "       LI(0)=DCMPLX(0)"
#write <li.F.2> "C ----------------------------------------------------------------------"
#write <li.F.2> "      return"
#write <li.F.2> "      end"
#close <li.F.2>
#write <lidefinitions.hf> "      double complex LI(0:`$numberfunctions')"
#write <lidefinitions.hf> "      common /loopvalues/ LI"
#close <lidefinitions.hf>

.end

*$Id: joinff.frm,v 1.27 2006/09/26 10:38:07 alorca Exp $
