C File <b0w.F> containing the B0 function for finite width
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      double complex function B0w(index,
     &     P1S, !external momenta
     &     cM1S,cM2S)
C-----------------------------------------------------------------------
      implicit none
      integer index
      double precision P1S
      double complex cM1S, cM2S
      double precision widthalltogether, minmass

      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
#include <variablelist.hf>
#include <looptools.h>
C-----------------------------------------------------------------------
C If we don't deal with a finite width, let's use real masses
      widthalltogether=IMAG(cM1S+cM2S)
      minmass=DBLE(cM1S)
      if (DBLE(cM2S).LT.minmass) minmass=DBLE(cM2S)
      if (.NOT.lwidth) then
 10     B0w=B0i(index,P1S,DBLE(cM1S),DBLE(cM2S))
        return
c      elseif ((widthalltogether.EQ.0d0).OR.(minmass.GT.0d0)) then
c        goto 10
c      elseif (P1S.LT.0d0) then
c        goto 10
      endif
      
      B0w=B0iC(index,DCMPLX(P1S),cM1S,cM2S)

C-----------------------------------------------------------------------
      return
      end

CC $Id: b0w.F,v 1.5 2006/09/04 13:23:00 alorca Exp $
